import { createAstro } from "./astro-global.js";
import { renderEndpoint } from "./endpoint.js";
import {
  escapeHTML,
  HTMLString,
  markHTMLString,
  markHTMLString as markHTMLString2
} from "./escape.js";
import { createMetadata } from "./metadata.js";
import {
  addAttribute,
  defineScriptVars,
  Fragment,
  maybeRenderHead,
  renderAstroComponent,
  renderComponent,
  Renderer,
  renderHead,
  renderHTMLElement,
  renderPage,
  renderSlot,
  renderTemplate,
  renderTemplate as renderTemplate2,
  renderToString,
  stringifyChunk,
  voidElementNames
} from "./render/index.js";
import { markHTMLString as markHTMLString3 } from "./escape.js";
import { Renderer as Renderer2 } from "./render/index.js";
import { addAttribute as addAttribute2 } from "./render/index.js";
function createComponent(cb) {
  cb.isAstroComponentFactory = true;
  return cb;
}
function mergeSlots(...slotted) {
  const slots = {};
  for (const slot of slotted) {
    if (!slot)
      continue;
    if (typeof slot === "object") {
      Object.assign(slots, slot);
    } else if (typeof slot === "function") {
      Object.assign(slots, mergeSlots(slot()));
    }
  }
  return slots;
}
function __astro_tag_component__(Component, rendererName) {
  if (!Component)
    return;
  if (typeof Component !== "function")
    return;
  Object.defineProperty(Component, Renderer2, {
    value: rendererName,
    enumerable: false,
    writable: false
  });
}
function spreadAttributes(values, _name, { class: scopedClassName } = {}) {
  let output = "";
  if (scopedClassName) {
    if (typeof values.class !== "undefined") {
      values.class += ` ${scopedClassName}`;
    } else if (typeof values["class:list"] !== "undefined") {
      values["class:list"] = [values["class:list"], scopedClassName];
    } else {
      values.class = scopedClassName;
    }
  }
  for (const [key, value] of Object.entries(values)) {
    output += addAttribute2(value, key, true);
  }
  return markHTMLString3(output);
}
function defineStyleVars(defs) {
  let output = "";
  let arr = !Array.isArray(defs) ? [defs] : defs;
  for (const vars of arr) {
    for (const [key, value] of Object.entries(vars)) {
      if (value || value === 0) {
        output += `--${key}: ${value};`;
      }
    }
  }
  return markHTMLString3(output);
}
export {
  Fragment,
  HTMLString,
  Renderer,
  __astro_tag_component__,
  addAttribute,
  createAstro,
  createComponent,
  createMetadata,
  defineScriptVars,
  defineStyleVars,
  escapeHTML,
  markHTMLString,
  maybeRenderHead,
  mergeSlots,
  renderTemplate as render,
  renderAstroComponent,
  renderComponent,
  renderEndpoint,
  renderHTMLElement,
  renderHead,
  renderPage,
  renderSlot,
  renderTemplate2 as renderTemplate,
  renderToString,
  spreadAttributes,
  stringifyChunk,
  markHTMLString2 as unescapeHTML,
  voidElementNames
};
